
// forditas:
//      flex egyszeru.l
//      bisonc++ egyszeru.y
//      g++ foprogram.cc lex.yy.cc parse.cc kodgenerator.cc Parser.cc

// az igy keletkezett a.out programot meghivva a forrasra
// kiirja a sztenderd kimenetre a leforditott assembly kodot



%baseclass-preinclude "preinclude.h"

%union
{
    std::string*                tipus;
    kifejezes_leiro*            kif;
    atom_leiro*                 atom;
}

%token PROGRAM KIIR ERTEKADAS KONSTANS
%token <tipus>      TIPUS
%token <atom>       AZONOSITO
%token <atom>       SZAMKONSTANS
%token <atom>       LOGIKAI_IGAZ
%token <atom>       LOGIKAI_HAMIS


%type <kif>         kifejezes
%type <kif>         atomi_kifejezes
%type <kif>         konstans_kifejezes
%type <atom>        valtozo
%type <atom>        konstans

%start start

%%


start:
        { kodgenerator::prologus(); }
    valtozodeklaraciok
    PROGRAM
        { kodgenerator::kod_prologus(); }
    utasitasok
        { kodgenerator::kod_epilogus(); }
;

valtozodeklaraciok:

|
    valtozodeklaracio
    valtozodeklaraciok
;


valtozodeklaracio:
    TIPUS
    AZONOSITO
        { kodgenerator::valtozo_deklaracio(*$1, *$2->valtozo);
          szimbolumtablaba_feljegyez(*$1, *$2->valtozo); }
|
    KONSTANS
    TIPUS
    AZONOSITO
    ERTEKADAS
    konstans
        { tipus_vizsgalat(*$2, *$5->tipus);
          kodgenerator::konstans_deklaracio(*$5, *$3->valtozo);
          szimbolumtablaba_feljegyez(*$2, *$3->valtozo); }
;

konstans:
    SZAMKONSTANS
|
    LOGIKAI_IGAZ
|
    LOGIKAI_HAMIS
;


utasitasok:

|
    utasitas
    utasitasok
;


utasitas:
    KIIR
    kifejezes
        { kodgenerator::akku_felold($2->cim_szerint, $2->tipus, kodgenerator::akku);
          kodgenerator::utasitas_kiir($2->tipus); }
;


kifejezes:
    atomi_kifejezes
;

atomi_kifejezes:
    valtozo
        { $$ = new kifejezes_leiro(*$1->tipus, true); }
|
    konstans_kifejezes
;

valtozo:
    AZONOSITO
        { kodgenerator::valtozo_azon($1); }
;

konstans_kifejezes:
    SZAMKONSTANS
        { kodgenerator::kif_szamkonstans(*$1);
          $$ = new kifejezes_leiro(*$1->tipus, false);
        }
|
    LOGIKAI_IGAZ
        { kodgenerator::kif_igaz();
          $$ = new kifejezes_leiro("bool", false);
        }
|
    LOGIKAI_HAMIS
        { kodgenerator::kif_hamis();
          $$ = new kifejezes_leiro("bool", false);
        }
;
