#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <sstream>
#include "Parser.h"
#include <FlexLexer.h>

using namespace std;

yyFlexLexer *fl;

int Parser::lex()
{
    int ret = fl->yylex();
    if( ret == Parser::AZONOSITO )
    {
        string nev = fl->YYText();
        if (szimbolumtabla_valtozo.count(nev) != 0)
        {
            d_val__.atom = new atom_leiro(szimbolumtabla_valtozo[nev], nev);
        }
        else
        {
            d_val__.atom = new atom_leiro("ismeretlen", nev);
        }
    }
    if( ret == Parser::TIPUS )
    {
        d_val__.tipus = new string(fl->YYText());
    }
    if( ret == Parser::SZAMKONSTANS )
    {
        d_val__.atom = new atom_leiro(atoi(fl->YYText()));
    }
    if( ret == Parser::LOGIKAI_IGAZ )
    {
        d_val__.atom = new atom_leiro(true);
    }
    if( ret == Parser::LOGIKAI_HAMIS )
    {
        d_val__.atom = new atom_leiro(false);
    }
    return ret;
}

void input_handler( ifstream& in, int argc, char* argv[] );

int main( int argc, char* argv[] )
{
    ifstream in;
    input_handler( in, argc, argv );
    fl = new yyFlexLexer(&in, &cout);
    Parser pars;
    pars.parse();
    return 0;
}

void input_handler( ifstream& in, int argc, char* argv[] )
{
    if( argc < 2 )
    {
        cerr << "A forditando fajl nevet parancssori parameterben kell megadni." << endl;
        exit(1);
    }
    in.open( argv[1] );
    if( !in )
    {
        cerr << "A " << argv[1] << "fajlt nem sikerult megnyitni." << endl;
        exit(1);
    }
}
