
%option noyywrap c++

%{
#include <iostream>
#include "Parser.h"

using namespace std;

void kiir(string token)
{
    cout << "; token " << token << endl;
}

void kiir_azon(string token)
{
    cout << "; token azonosito " << token << endl;
}

void kiir_konst(string token)
{
    cout << "; token konstans " << token << endl;
}

%}


%%

int         { kiir(YYText());  return Parser::TIPUS; }
bool        { kiir(YYText());  return Parser::TIPUS; }

print       { kiir(YYText());  return Parser::KIIR; }

program     { kiir(YYText());  return Parser::PROGRAM; }

true        { kiir(YYText());  return Parser::LOGIKAI_IGAZ; }
false       { kiir(YYText());  return Parser::LOGIKAI_HAMIS; }

":="        { kiir(YYText());  return Parser::ERTEKADAS; }

constant    { kiir(YYText());  return Parser::KONSTANS; }

not         { kiir(YYText());  return Parser::NEGACIO; }
and         { kiir(YYText());  return Parser::LUSTAES; }
or          { kiir(YYText());  return Parser::LUSTAVAGY; }
and_strict  { kiir(YYText());  return Parser::MOHOES; }
or_strict   { kiir(YYText());  return Parser::MOHOVAGY; }

"+"         { kiir(YYText());  return Parser::PLUSZ; }
"*"         { kiir(YYText());  return Parser::SZORZAS; }

"<"         { kiir(YYText());  return Parser::KISEBB; }
"="         { kiir(YYText());  return Parser::EGYENLO; }

"("         { kiir(YYText());  return Parser::NYITO; }
")"         { kiir(YYText());  return Parser::CSUKO; }

[0-9]+      { kiir_konst(YYText());  return Parser::SZAMKONSTANS; }
[a-zA-z]+   { kiir_azon(YYText());  return Parser::AZONOSITO; }

[ \t\n]+    // eldobjuk

%%

