
// forditas:
//      flex egyszeru.l
//      bisonc++ egyszeru.y
//      g++ foprogram.cc lex.yy.cc parse.cc kodgenerator.cc Parser.cc

// az igy keletkezett a.out programot meghivva a forrasra
// kiirja a sztenderd kimenetre a leforditott assembly kodot



%baseclass-preinclude "preinclude.h"

%union
{
    std::string*                tipus;
    kifejezes_leiro*            kif;
    atom_leiro*                 atom;
}

%token IF THEN ELSE ENDIF

%token NYITO CSUKO

%token PROGRAM KIIR ERTEKADAS KONSTANS
%token <tipus>      TIPUS
%token <atom>       AZONOSITO
%token <atom>       SZAMKONSTANS
%token <atom>       LOGIKAI_IGAZ
%token <atom>       LOGIKAI_HAMIS

//---------------------
// fontos a sorrend a precedenciak miatt
// precedenciak: lefele erosodnek

%left MOHOVAGY MOHOES
%left LUSTAVAGY LUSTAES
%left NEGACIO

%nonassoc KISEBB EGYENLO

%left PLUSZ
%left SZORZAS
//---------------------

%type <kif>         kifejezes
%type <kif>         atomi_kifejezes
%type <kif>         konstans_kifejezes
%type <atom>        valtozo
%type <atom>        konstans

%start start

%%

// -------------------------------------------------------------------
// a nyelvtanhoz hozzáadott rész ebben a fázisban
utasitas:
    IF
    kifejezes
        { tipus_vizsgalat($2->tipus, std::string("bool"));
          kodgenerator::akku_felold($2->cim_szerint, $2->tipus, kodgenerator::akku);
          std::string hamis_ag_cimke = uj_cimke("elagazas_hamis_ag");
          kodgenerator::ugras_hamis_akku(hamis_ag_cimke); }
    THEN
    utasitasok
    else
    ENDIF
        { std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke); }
;


else:

|
    ELSE
        { std::string hamis_ag_cimke = cimket_atvesz();
          std::string vege_cimke = uj_cimke("elagazas_vege");
          kodgenerator::ugras(vege_cimke);
          kodgenerator::cimket_elhelyez(hamis_ag_cimke); }
    utasitasok
;

// -------------------------------------------------------------------


start:
        { kodgenerator::prologus(); }
    valtozodeklaraciok
    PROGRAM
        { kodgenerator::kod_prologus(); }
    utasitasok
        { kodgenerator::kod_epilogus(); }
;










valtozodeklaraciok:

|
    valtozodeklaracio
    valtozodeklaraciok
;


valtozodeklaracio:
    KONSTANS
    TIPUS
    AZONOSITO
    ERTEKADAS
    konstans
        { tipus_vizsgalat(*$2, *$5->tipus);
          kodgenerator::konstans_deklaracio(*$5, *$3->valtozo);
          szimbolumtablaba_feljegyez(*$2, *$3->valtozo); }
;

konstans:
    SZAMKONSTANS
|
    LOGIKAI_IGAZ
|
    LOGIKAI_HAMIS
;













valtozodeklaracio:
    TIPUS
    AZONOSITO
        { kodgenerator::valtozo_deklaracio(*$1, *$2->valtozo);
          szimbolumtablaba_feljegyez(*$1, *$2->valtozo); }
;
















utasitasok:

|
    utasitas
    utasitasok
;

utasitas:
    valtozo
    ERTEKADAS
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat(*$1->tipus, $4->tipus);
          // lenyeges: itt nem oldjuk fel $1-et!
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::utasitas_ertekadas($4->tipus); }
;






kifejezes:
    atomi_kifejezes
;

atomi_kifejezes:
    valtozo
        { $$ = new kifejezes_leiro(*$1->tipus, true); }
|
    konstans_kifejezes
;

valtozo:
    AZONOSITO
        { kodgenerator::valtozo_azon($1); }
;

konstans_kifejezes:
    SZAMKONSTANS
        { kodgenerator::kif_szamkonstans(*$1);
          $$ = new kifejezes_leiro(*$1->tipus, false);
        }
|
    LOGIKAI_IGAZ
        { kodgenerator::kif_igaz();
          $$ = new kifejezes_leiro("bool", false);
        }
|
    LOGIKAI_HAMIS
        { kodgenerator::kif_hamis();
          $$ = new kifejezes_leiro("bool", false);
        }
;









kifejezes:
    NYITO
    kifejezes
    CSUKO
        { $$ = $2; }
|
    NEGACIO
    kifejezes
        { tipus_vizsgalat($2->tipus, std::string("bool"));
          kodgenerator::akku_felold($2->cim_szerint, $2->tipus, kodgenerator::akku);
          kodgenerator::muvelet_negacio();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    PLUSZ
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::adat);
          kodgenerator::muvelet_plusz();
          $$ = new kifejezes_leiro("int", false); }
|
    kifejezes
    SZORZAS
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::adat);
          kodgenerator::muvelet_szorzas();
          $$ = new kifejezes_leiro("int", false); }
|
    kifejezes
    MOHOES
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "bool");
          tipus_vizsgalat($4->tipus, "bool");
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::adat);
          kodgenerator::muvelet_konjunkcio();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    MOHOVAGY
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "bool");
          tipus_vizsgalat($4->tipus, "bool");
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::adat);
          kodgenerator::muvelet_diszjunkcio();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    EGYENLO
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::adat);
          kodgenerator::muvelet_egyenlo();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    KISEBB
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::adat);
          kodgenerator::muvelet_kisebb();
          $$ = new kifejezes_leiro("bool", false); }
;













kifejezes:
    kifejezes
    LUSTAVAGY
        { tipus_vizsgalat($1->tipus, std::string("bool"));
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::akku);
          std::string vege_cimke = uj_cimke("rovidzaras_vagy");
          kodgenerator::ugras_igaz_akku(vege_cimke); }
    kifejezes
        { tipus_vizsgalat($4->tipus, std::string("bool"));
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke);
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    LUSTAES
        { tipus_vizsgalat($1->tipus, std::string("bool"));
          kodgenerator::akku_felold($1->cim_szerint, $1->tipus, kodgenerator::akku);
          std::string vege_cimke = uj_cimke("rovidzaras_es");
          kodgenerator::ugras_hamis_akku(vege_cimke); }
    kifejezes
        { tipus_vizsgalat($4->tipus, std::string("bool"));
          kodgenerator::akku_felold($4->cim_szerint, $4->tipus, kodgenerator::akku);
          std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke);
          $$ = new kifejezes_leiro("bool", false); }
;









































utasitas:
    KIIR
    kifejezes
        { kodgenerator::akku_felold($2->cim_szerint, $2->tipus, kodgenerator::akku);
          kodgenerator::utasitas_kiir($2->tipus); }
;
