
#include "Parser.h"
#include <stdlib.h>
#include <iostream>
#include <string>
#include <sstream>

using namespace std;


const char kodgenerator::tab = '\t';


void kodgenerator::prologus()
{
    cout <<
        tab << "extern printf" << endl <<
        tab << "section .data" << endl <<
        "kiiro_formatum" << tab << "db" << tab << "\"%d\", 10, 0\n" << endl;
}


void kodgenerator::kod_prologus()
{
    cout <<
        tab << "global main" << endl <<
        tab << "section .text" << endl <<
        "main:" << endl <<
        tab << "push ebp" << endl <<
        tab << "mov ebp, esp" << endl;
}


void kodgenerator::kod_epilogus()
{
    cout << endl <<
        tab << "mov esp, ebp" << endl <<
        tab << "pop ebp" << endl <<
        tab << "ret" << endl;
}


void kodgenerator::valtozo_azon(atom_leiro* atom)
{
    cout <<
        tab << "mov eax, " << *(atom->valtozo) << endl;
}



void kodgenerator::valtozo_deklaracio(string tipus, string valtozo)
{
    string* meret;

    if (tipus == "int")     meret = new string("resd");
    else if (tipus == "bool")    meret = new string("resb");
    else
    {
        cerr << "Ismeretlen tipus: \"" << tipus << '"' << endl;
        meret = new string("resd");
    }

    cout <<
        tab << "section .bss" << endl << endl <<
        valtozo << tab << *meret << tab << "1" << endl << endl;

    delete meret;
}


void kodgenerator::konstans_deklaracio(atom_leiro konstans, string nev)
{
    if (*(konstans.tipus) == "int")
    {
        cout <<
            tab << "section .data" << endl <<
            nev << tab << "dd" << tab << konstans.ertek << endl << endl;
    }
    else if (*(konstans.tipus) == "bool")
    {
        cout <<
            tab << "section .data" << endl <<
            nev << tab << "db" << tab << konstans.logikai << endl << endl;
    }
    else
    {
        cerr << "Ismeretlen tipus: \"" << konstans.tipus << '"' << endl;
    }
}

void kodgenerator::kif_szamkonstans(atom_leiro leiro)
{
    cout <<
        tab << "mov eax, " << leiro.ertek << endl;
}





void kodgenerator::ment_akku()
{
    cout <<
        tab << "push eax" << endl;
}

void kodgenerator::tolt_adat()
{
    cout <<
        tab << "pop edx" << endl;
}

void kodgenerator::utasitas_ertekadas(string tipus)
{
    if (tipus == "int")
    {
        cout <<
            tab << "mov [edx], eax" << endl;
    }
    else if (tipus == "bool")
    {
        cout <<
            tab << "mov [edx], al" << endl;
    }
    else
    {
        cerr << "Ismeretlen tipus" << tipus << endl;
        exit(1);
    }
}

void kodgenerator::utasitas_kiir(string tipus)
{
    if (tipus == "int")
    {
        cout << endl <<
            tab << "push eax" << endl <<
            tab << "push kiiro_formatum" << endl <<
            tab << "call printf" << endl <<
            tab << "add esp, 8" << endl;
    }
    else if (tipus == "bool")
    {
        cout << endl <<
            tab << "and eax, 1" << endl <<
            tab << "push eax" << endl <<
            tab << "push kiiro_formatum" << endl <<
            tab << "call printf" << endl <<
            tab << "add esp, 8" << endl;
    }
    else
    {
        cerr<<"Ismeretlen tipus: " << tipus;
        exit(1);
    }
}


void kodgenerator::muvelet_plusz()
{
    cout << endl <<
        tab << "add eax, edx" << endl;
}

void kodgenerator::muvelet_szorzas()
{
    cout << endl <<
        tab << "mul edx" << endl;
}


void kodgenerator::muvelet_negacio()
{
    cout <<
        tab << "xor al, 1" << endl;
}


void kodgenerator::muvelet_konjunkcio()
{
    cout <<
        tab << "and eax, edx" << endl;
}

void kodgenerator::muvelet_diszjunkcio()
{
    cout <<
        tab << "or eax, edx" << endl;
}

void kodgenerator::muvelet_kisebb()
{
    cout <<
        tab << "cmp edx, eax" << endl <<
        tab << "setl al" << endl;
}

void kodgenerator::muvelet_egyenlo()
{
    cout <<
        tab << "cmp edx, eax" << endl <<
        tab << "sete al" << endl;
}




void kodgenerator::kif_igaz()
{
    cout << endl <<
        tab << "mov eax, 1" << endl;
}

void kodgenerator::kif_hamis()
{
    cout << endl <<
        tab << "xor eax, eax" << endl;
}


void kodgenerator::ugras_hamis_akku(string cimke)
{
    cout <<
        tab << "cmp al, 0" << endl <<
        tab << "je near " << cimke << endl;
}

void kodgenerator::ugras_igaz_akku(string cimke)
{
    cout <<
        tab << "cmp al, 1" << endl <<
        tab << "je near " << cimke << endl;
}

void kodgenerator::ugras(string cimke)
{
    cout <<
        tab << "jmp " << cimke << endl;
}

void kodgenerator::cimket_elhelyez(string cimke)
{
    cout << endl <<
        cimke << ":" << endl;
}


void kodgenerator::akku_felold(bool cim_szerint, string tipus, felold f)
{
    if (cim_szerint)
    {
        string reg;
        if (f == akku)    reg = "eax";
        else              reg = "edx";

        if (tipus == "int")
        {
            cout <<
                tab << "mov " << reg << ", [" << reg << "]" << endl;
        }
        else if (tipus == "bool")
        {
            cout <<
                tab << "movzx " << reg << ", byte [" << reg << "]" << endl;
        }
    } else {
        // ertek szerint: eax-ban van az ertek
    }
}
