
#include "Parser.h"
#include <stdlib.h>
#include <iostream>
#include <string>
#include <sstream>

using namespace std;


int  Parser::index = 0;

Parser::Parser()
{
    orokolt_cimkek = new std::stack<std::string>();
}

alprogram_leiro* Parser::aktualis_alprogram()
{
    if (szimbolumtabla_alprogram.count(_aktualis_alprogram) == 0)
    {
        return 0;
    }

    return szimbolumtabla_alprogram[_aktualis_alprogram];
}

void Parser::szimbolumtablaba_feljegyez(string tipus, string nev)
{
    if (szimbolumtabla_valtozo.count(nev) != 0)
    {
        cerr << "Tobbszorosen deklaralt valtozo: " << nev << endl;
        exit(1);
    }

    szimbolumtabla_valtozo[nev] = tipus;
}


void Parser::alprogramtablaba_feljegyez(
   string nev, string visszateres,
   list<pair<string, string> > parameterek, string vege_cimke)
{
    if (szimbolumtabla_alprogram.count(nev) != 0)
    {
        cerr << "Tobbszorosen deklaralt alprogram: " << nev << endl;
        exit(1);
    }

    szimbolumtabla_alprogram[nev]
        = new alprogram_leiro(nev, visszateres, parameterek, vege_cimke);
}


string Parser::azonosito_tipusa(string azonosito)
{
    if (szimbolumtabla_valtozo.count(azonosito) == 0)
    {
        cerr << "Ismeretlen valtozo: " << azonosito << endl;
        exit(1);
    }

    return szimbolumtabla_valtozo[azonosito];
}


void Parser::tipus_vizsgalat(string tipus1, string tipus2)
{
    cout << "; tipusvizsgalat: " << tipus1 << ", " << tipus2 << endl;
    if ( tipus1 != tipus2 )
    {
        cout << "; !!!!! Tipushiba: " << tipus1 << ", " << tipus2 << endl;
    }
}

string Parser::uj_cimke(string utotag)
{
    stringstream  s;
    s << "__c" << ++index << "_" << utotag;

    // 5-ben, elotte elrontja!
    orokolt_cimkek->push(s.str());

    return s.str();
}


string Parser::cimket_atvesz()
{
    string s = orokolt_cimkek->top();
    orokolt_cimkek->pop();
    return s;
}


void Parser::hiba_ha_nincs_main_alprogram()
{
    if (szimbolumtabla_alprogram.count("main") == 0)
    {
        cerr << "Hiba: nincs main alprogram!" << endl;
        exit(1);
    }
}
