
%baseclass-preinclude "preinclude.h"

%union
{
    std::string*                tipus;
    kifejezes_leiro*            kif;
    atom_leiro*                 atom;
    std::list<std::string>*     aparam;
    std::list<std::pair<std::string, std::string> >*     fparam;
}

%token IF THEN ELSE ENDIF
%token LOOP ENDLOOP WHILE DO DONE
%token ALPROGRAM_FEJLEC ALPROGRAM_KEZDETE ALPROGRAM_VEGE VISSZATERES
%token VESSZO

%token NYITO CSUKO

%token KIIR ERTEKADAS KONSTANS
%token <tipus>      TIPUS
%token <atom>       AZONOSITO
%token <atom>       SZAMKONSTANS
%token <atom>       LOGIKAI_IGAZ
%token <atom>       LOGIKAI_HAMIS

//---------------------
// fontos a sorrend a precedenciak miatt
// az alsok kotnek erosebben

%left MOHOVAGY MOHOES
%left LUSTAVAGY LUSTAES
%left NEGACIO

%nonassoc KISEBB EGYENLO

%left PLUSZ
%left SZORZAS
//---------------------

%type <kif>         kifejezes
%type <kif>         atomi_kifejezes
%type <kif>         konstans_kifejezes
%type <kif>         alprogram_hivas
%type <atom>        valtozo
%type <atom>        konstans
%type <fparam>      formalis_parameterlista
%type <fparam>      nemures_formalis_parameterlista
%type <aparam>      aktualis_parameterlista
%type <aparam>      maradek_aktualis_parameterlista

%%

start:
        { kodgenerator::prologus(); }
    program
        { hiba_ha_nincs_main_alprogram(); }
;

program:

|
    alprogram_deklaracio
    program
;










alprogram_deklaracio:
    ALPROGRAM_FEJLEC
    TIPUS
    AZONOSITO
        { _aktualis_alprogram = *$3->valtozo; }
    NYITO
    formalis_parameterlista
    CSUKO
    valtozodeklaraciok
        { std::string vege_cimke = uj_cimke("alprogram_vege");
          alprogramtablaba_feljegyez(*$3->valtozo, *$2, *$6, vege_cimke);
          kodgenerator::alprogram_prologus(*$3->valtozo, *$6); }
    ALPROGRAM_KEZDETE
    utasitasok
        { std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke);
          kodgenerator::alprogram_epilogus(); }
    ALPROGRAM_VEGE
;

formalis_parameterlista:

        { $$ = new std::list<std::pair<std::string, std::string> >(); }
|
    nemures_formalis_parameterlista
;


nemures_formalis_parameterlista:
    TIPUS
    AZONOSITO
        { $$ = new std::list<std::pair<std::string, std::string> >();
          $$->push_front(std::pair<std::string, std::string>(*$1, *$2->valtozo)); }
|
    TIPUS
    AZONOSITO
    VESSZO
    nemures_formalis_parameterlista
        { $$ = $4;
          $$->push_front(std::pair<std::string, std::string>(*$1, *$2->valtozo)); }
;



kifejezes:
    alprogram_hivas
;

alprogram_hivas:
    AZONOSITO
    NYITO
    aktualis_parameterlista
    CSUKO
        { kodgenerator::alprogram_hivas(*$1->valtozo);
          alprogram_leiro* alprogram = szimbolumtabla_alprogram[*$1->valtozo];
          kodgenerator::verem_rendezese($3);
          $$ = new kifejezes_leiro(alprogram->visszateres, false); }
;

aktualis_parameterlista:

        { $$ = new std::list<std::string>(); }
|
    kifejezes
        { kodgenerator::akku_felold($1, kodgenerator::akku);
          kodgenerator::aktualis_parameter($1); }
    maradek_aktualis_parameterlista
        { $$ = $3;
          $$->push_front($1->tipus); }
;


maradek_aktualis_parameterlista:
    { $$ = new std::list<std::string>(); }
|
    VESSZO
    kifejezes
        { kodgenerator::akku_felold($2, kodgenerator::akku);
          kodgenerator::aktualis_parameter($2); }
    maradek_aktualis_parameterlista
        { $$ = new std::list<std::string>();
          $$->push_front($2->tipus); }
;

utasitas:
    visszateres
;

visszateres:
    VISSZATERES
    kifejezes
        { alprogram_leiro* aktualis = aktualis_alprogram();
          tipus_vizsgalat($2->tipus, aktualis->visszateres);
          kodgenerator::akku_felold($2, kodgenerator::akku);
          std::string vege_cimke = aktualis->vege_cimke;
          kodgenerator::ugras(vege_cimke);
        }
;


valtozo:
    AZONOSITO
        { alprogram_leiro* alprogram = aktualis_alprogram();
          $$ = kodgenerator::valtozo_azon($1, alprogram); }
;


//
// Innentol lefele nincsen valtozas.
//
//
//
//
//
//



valtozodeklaraciok:

|
    valtozodeklaracio
    valtozodeklaraciok
;


valtozodeklaracio:
    TIPUS
    AZONOSITO
        { kodgenerator::valtozo_deklaracio(*$1, *$2->valtozo);
          szimbolumtablaba_feljegyez(*$1, *$2->valtozo); }
|
    KONSTANS
    TIPUS
    AZONOSITO
    ERTEKADAS
    konstans
        { tipus_vizsgalat(*$2, *$5->tipus);
          kodgenerator::konstans_deklaracio(*$5, *$3->valtozo);
          szimbolumtablaba_feljegyez(*$2, *$3->valtozo); }
;

konstans:
    SZAMKONSTANS
|
    LOGIKAI_IGAZ
|
    LOGIKAI_HAMIS
;

utasitasok:

|
    utasitas
    utasitasok
;

utasitas:
    KIIR
    kifejezes
        { kodgenerator::akku_felold($2, kodgenerator::akku);
          kodgenerator::utasitas_kiir($2->tipus); }
|
    valtozo
    ERTEKADAS
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat(*$1->tipus, $4->tipus);
          // itt nem oldjuk fel $1-et!
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::utasitas_ertekadas($4->tipus); }
|
    LOOP
        { std::string eleje_cimke = uj_cimke("vegtelen_ciklus_eleje");
          kodgenerator::cimket_elhelyez(eleje_cimke); }
    utasitasok
    ENDLOOP
        { std::string eleje_cimke = cimket_atvesz();
          kodgenerator::ugras(eleje_cimke); }
|
    WHILE
        { std::string eleje_cimke = uj_cimke("eloltesztelo_ciklus_eleje");
          kodgenerator::cimket_elhelyez(eleje_cimke); }
    kifejezes
        { tipus_vizsgalat($3->tipus, std::string("bool"));
          kodgenerator::akku_felold($3, kodgenerator::akku);
          std::string vege_cimke  = uj_cimke("eloltesztelo_ciklus_vege");
          kodgenerator::ugras_hamis_akku(vege_cimke); }
    DO
    utasitasok
    DONE
        { std::string vege_cimke  = cimket_atvesz();
          std::string eleje_cimke = cimket_atvesz();
          kodgenerator::ugras(eleje_cimke);
          kodgenerator::cimket_elhelyez(vege_cimke); }
|
    IF
    kifejezes
        { tipus_vizsgalat($2->tipus, std::string("bool"));
          kodgenerator::akku_felold($2, kodgenerator::akku);
          std::string hamis_ag_cimke = uj_cimke("elagazas_hamis_ag");
          kodgenerator::ugras_hamis_akku(hamis_ag_cimke); }
    THEN
    utasitasok
    else
    ENDIF
        { std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke); }
;


else:

|
    ELSE
        { std::string hamis_ag_cimke = cimket_atvesz();
          std::string vege_cimke = uj_cimke("elagazas_vege");
          kodgenerator::ugras(vege_cimke);
          kodgenerator::cimket_elhelyez(hamis_ag_cimke); }
    utasitasok
;

kifejezes:
    atomi_kifejezes
|
    NYITO
    kifejezes
    CSUKO
        { $$ = $2; }
|
    NEGACIO
    kifejezes
        { tipus_vizsgalat($2->tipus, std::string("bool"));
          kodgenerator::akku_felold($2, kodgenerator::akku);
          kodgenerator::muvelet_negacio();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    PLUSZ
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1, kodgenerator::adat);
          kodgenerator::muvelet_plusz();
          $$ = new kifejezes_leiro("int", false); }
|
    kifejezes
    SZORZAS
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
std::cout << ";mostront" << std::endl;
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1, kodgenerator::adat);
          kodgenerator::muvelet_szorzas();
          $$ = new kifejezes_leiro("int", false); }
|
    kifejezes
    MOHOES
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "bool");
          tipus_vizsgalat($4->tipus, "bool");
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1, kodgenerator::adat);
          kodgenerator::muvelet_konjunkcio();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    MOHOVAGY
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "bool");
          tipus_vizsgalat($4->tipus, "bool");
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1, kodgenerator::adat);
          kodgenerator::muvelet_diszjunkcio();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    EGYENLO
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1, kodgenerator::adat);
          kodgenerator::muvelet_egyenlo();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    KISEBB
        { kodgenerator::ment_akku(); }
    kifejezes
        { tipus_vizsgalat($1->tipus, "int");
          tipus_vizsgalat($4->tipus, "int");
          kodgenerator::akku_felold($4, kodgenerator::akku);
          kodgenerator::tolt_adat();
          kodgenerator::akku_felold($1, kodgenerator::adat);
          kodgenerator::muvelet_kisebb();
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    LUSTAVAGY
        { tipus_vizsgalat($1->tipus, std::string("bool"));
          kodgenerator::akku_felold($1, kodgenerator::akku);
          std::string vege_cimke = uj_cimke("rovidzaras_vagy");
          kodgenerator::ugras_igaz_akku(vege_cimke); }
    kifejezes
        { tipus_vizsgalat($4->tipus, std::string("bool"));
          kodgenerator::akku_felold($4, kodgenerator::akku);
          std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke);
          $$ = new kifejezes_leiro("bool", false); }
|
    kifejezes
    LUSTAES
        { tipus_vizsgalat($1->tipus, std::string("bool"));
          kodgenerator::akku_felold($1, kodgenerator::akku);
          std::string vege_cimke = uj_cimke("rovidzaras_es");
          kodgenerator::ugras_hamis_akku(vege_cimke); }
    kifejezes
        { tipus_vizsgalat($4->tipus, std::string("bool"));
          kodgenerator::akku_felold($4, kodgenerator::akku);
          std::string vege_cimke = cimket_atvesz();
          kodgenerator::cimket_elhelyez(vege_cimke);
          $$ = new kifejezes_leiro("bool", false); }
;

atomi_kifejezes:
    valtozo
        { $$ = new kifejezes_leiro(*$1->tipus, true); }
|
    konstans_kifejezes
;

konstans_kifejezes:
    SZAMKONSTANS
        { kodgenerator::kif_szamkonstans(*$1);
          $$ = new kifejezes_leiro(*$1->tipus, false);
        }
|
    LOGIKAI_IGAZ
        { kodgenerator::kif_igaz();
          $$ = new kifejezes_leiro("bool", false);
        }
|
    LOGIKAI_HAMIS
        { kodgenerator::kif_hamis();
          $$ = new kifejezes_leiro("bool", false);
        }
;


